#ifndef __IntensityScreen
#define __IntensityScreen

#include "ScreenManager.h"
#include "Screen/BaseMenuScreen.h"

/*
 * Intensity screen
 *   Allows changing of the intensity.
 */
class IntensityScreen : public BaseMenuScreen
{
  protected:
    inline bool getEditMode() { return !getEnableMenuScroll(); }
    inline void setEditMode(bool value) { setEnableMenuScroll(!value); }

    bool hasPrevious() { return true; }
    bool hasNext() { return true; }

    const char* getTitle() { return "Intensity"; }
    void gotoPrevious();
    void gotoNext();

    void printValue();

  public:
    IntensityScreen(ScreenManager* screenManager) : BaseMenuScreen(screenManager) { }

    void onHide();

    void onButton();
    void onEncoder(long lastPosition, long newPosition);
    void onTick();
};

#endif
