#ifndef __SetTimeScreen
#define __SetTimeScreen

#include "ScreenManager.h"
#include "Screen/BaseMenuScreen.h"

/*
 * Time screen
 *   Allows changing of the exposure time.
 */
class SetTimeScreen : public BaseMenuScreen
{
  protected:
    inline bool getEditMode() { return !getEnableMenuScroll(); }
    inline void setEditMode(bool value) { setEnableMenuScroll(!value); }

    bool hasPrevious() { return false; }
    bool hasNext() { return true; }

    const char* getTitle() { return "Time"; }
    void gotoNext();

    void printValue();

  public:
    SetTimeScreen(ScreenManager* screenManager) : BaseMenuScreen(screenManager) { }

    void onHide();

    void onButton();
    void onEncoder(long lastPosition, long newPosition);
    void onTick();
};

#endif
